//
// Page file functions
//

#include <cybiko.h>

const char vfile[]="storm.dmp";

void mem_dump(char *in,long size){
	struct FileOutput file_output;
	TRACE("vmem - saving (%ld)",size);

	FileOutput_ctor( &file_output );

	if( FileOutput_open( &file_output, vfile, TRUE ) ){
		FileOutput_write( &file_output,in,size);
	}else{
		TRACE("Error saving page file.");
	}

	FileOutput_dtor( &file_output, LEAVE_MEMORY );
}

void mem_restore(char *in,long size){
	struct FileInput file_input;
	TRACE("vmem - restoring (%ld)",size);

	FileInput_ctor(&file_input);

	if(FileInput_open( &file_input, vfile)){
		Input_read( &file_input,in,size);
	}else{
		TRACE("Error restoring page file.");
	}

	FileInput_dtor( &file_input, LEAVE_MEMORY);
}

