//
// XPic Viewer
//
// 03/09/2023: Tidy declarations / initialisations

#include <cybiko.h>

int waitinput(struct module_t *);

void xpic(char *myfile,struct module_t *ptr_main_module){
	struct FileInput file_input;
	char *dis,*scr;

	scr=(char *)calloc(8000,sizeof(char)); // max=160x100 @ 4bpp
	if (scr!=NULL){
		dis=DisplayGraphics_get_page_ptr(ptr_main_module->m_gfx, 0);

		FileInput_ctor(&file_input);

		if( !FileInput_open( &file_input, myfile) ){
			TRACE("Could not open file.");
		}else{
			char byt,c1,c2,c3,c4,exit=0;
			int i,pos=0;
			
			TRACE("Showing xpic: ",myfile);
			FileInput_seek( &file_input, 8, SEEK_SET );
			Input_read( &file_input,scr,8000);
			
			for(i=0;i<4000;i++){
				byt=scr[pos];
				c2=(byt & 0x0f)>>2;
				c1=(byt & 0xf0)>>6;
				
				byt=scr[pos+1];
				c4=(byt & 0x0f)>>2;
				c3=(byt & 0xf0)>>6;
				pos+=2;
				
				dis[i]=(c1<<6)+(c2<<4)+(c3<<2)+c4;
			}
			
			DisplayGraphics_show( ptr_main_module->m_gfx );

			do{
				switch(waitinput(ptr_main_module)){
					case KEY_ESC:
						exit=1;
					break;
				}
			
			}while(exit==0);
		}

		// Clean up
		FileInput_dtor( &file_input, LEAVE_MEMORY);
	}
	
	// Safe to leave here as freeing NULL (if not enough space) should be okay...
	free(scr);
}
